/* Cray T90 IEEE gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1996, 2000, 2001, 2002, 2004 Free Software
Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 64
#define BYTES_PER_MP_LIMB 8

/* Generated by tuneup.c, 2004-02-07, system compiler */

#define MUL_KARATSUBA_THRESHOLD         130
#define MUL_TOOM3_THRESHOLD             260

#define SQR_BASECASE_THRESHOLD            9  /* karatsuba */
#define SQR_KARATSUBA_THRESHOLD           0  /* never sqr_basecase */
#define SQR_TOOM3_THRESHOLD              34

#define DIV_SB_PREINV_THRESHOLD           0  /* preinv always */
#define DIV_DC_THRESHOLD                390
#define POWM_THRESHOLD                  656

#define HGCD_THRESHOLD                  964
#define GCD_ACCEL_THRESHOLD               3
#define GCD_DC_THRESHOLD                964
#define JACOBI_BASE_METHOD                2

#define DIVREM_1_NORM_THRESHOLD           0  /* preinv always */
#define DIVREM_1_UNNORM_THRESHOLD         0  /* always */
#define MOD_1_NORM_THRESHOLD              0  /* always */
#define MOD_1_UNNORM_THRESHOLD            0  /* always */
#define USE_PREINV_DIVREM_1               1  /* preinv always */
#define USE_PREINV_MOD_1                  1  /* preinv always */
#define DIVREM_2_THRESHOLD                0  /* preinv always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD             45
#define GET_STR_PRECOMPUTE_THRESHOLD     77
#define SET_STR_THRESHOLD            145756

#define MUL_FFT_TABLE  { 1104, 2208, 4416, 8960, 19456, 45056, 0 }
#define MUL_FFT_MODF_THRESHOLD         1168
#define MUL_FFT_THRESHOLD              6528

#define SQR_FFT_TABLE  { 368, 736, 1600, 2816, 7168, 12288, 0 }
#define SQR_FFT_MODF_THRESHOLD          296
#define SQR_FFT_THRESHOLD              1312
