/* Sparc64 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002, 2004, 2006, 2008, 2009
Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 64
#define BYTES_PER_MP_LIMB 8

/* Tell the toom3 multiply implementation to call low-level mpn
   functions instead of open-coding operations in C.  */
#ifndef USE_MORE_MPN
#define USE_MORE_MPN 1
#endif

/* Generated by tuneup.c, 2009-01-15, gcc 3.4 */

#define MUL_KARATSUBA_THRESHOLD          33
#define MUL_TOOM3_THRESHOLD             189
#define MUL_TOOM44_THRESHOLD            256

#define SQR_BASECASE_THRESHOLD            9
#define SQR_KARATSUBA_THRESHOLD          70
#define SQR_TOOM3_THRESHOLD             226
#define SQR_TOOM4_THRESHOLD             345

#define MULLOW_BASECASE_THRESHOLD         0  /* always */
#define MULLOW_DC_THRESHOLD              46
#define MULLOW_MUL_N_THRESHOLD          143

#define DIV_SB_PREINV_THRESHOLD           0  /* always */
#define DIV_DC_THRESHOLD                 34
#define POWM_THRESHOLD                  116

#define MATRIX22_STRASSEN_THRESHOLD      18
#define HGCD_THRESHOLD                   51
#define GCD_DC_THRESHOLD                293
#define GCDEXT_DC_THRESHOLD             198
#define JACOBI_BASE_METHOD                3

#define DIVREM_1_NORM_THRESHOLD           3
#define DIVREM_1_UNNORM_THRESHOLD         3
#define MOD_1_NORM_THRESHOLD              3
#define MOD_1_UNNORM_THRESHOLD            3
#define MOD_1_1_THRESHOLD                12
#define MOD_1_2_THRESHOLD                13
#define MOD_1_4_THRESHOLD                16
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                6
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD             13
#define GET_STR_PRECOMPUTE_THRESHOLD     21
#define SET_STR_DC_THRESHOLD            638
#define SET_STR_PRECOMPUTE_THRESHOLD   1889

#define MUL_FFT_TABLE  { 304, 608, 1600, 2816, 7168, 20480, 81920, 196608, 786432, 0 }
#define MUL_FFT_MODF_THRESHOLD          216
#define MUL_FFT_THRESHOLD              1664

#define SQR_FFT_TABLE  { 336, 736, 1600, 2816, 7168, 20480, 49152, 196608, 786432, 0 }
#define SQR_FFT_MODF_THRESHOLD          216
#define SQR_FFT_THRESHOLD              1312

